#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mpi.h>
#include "timing.h"

int main(int argc, char **argv) {
  unsigned int seed = 123;
  long hist[16], j, n, ntot, hist_tmp[16];
  int i, iproc, nproc;
  double wcstart,wcend,ct;
  MPI_Status status;
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&nproc);
  MPI_Comm_rank(MPI_COMM_WORLD,&iproc);
  ntot=2*pow(10,9);
  n=ntot/nproc+1;
  for(i=0; i<16; ++i)
    hist[i]=0;

  timing(&wcstart, &ct);
  
  for(j=0; j<n; ++j) {
    hist[rand_r(&seed) & 0xf]++;
  }
  if(iproc==0) {
    for(int jproc=1;jproc<nproc;jproc++) {
      MPI_Recv(hist_tmp,16,MPI_LONG,MPI_ANY_SOURCE,111,MPI_COMM_WORLD,&status);
      for(int i=0;i<16;i++) hist[i]+=hist_tmp[i];
    }
  }
  else {
    MPI_Send(hist,16,MPI_LONG,0,111,MPI_COMM_WORLD);
  }
  timing(&wcend, &ct);

  if(iproc==0) {
    for(i=0; i<16; ++i) {
      printf("hist[%d]=%ld\n",i,hist[i]);
    }
  }

  printf("Time: %lf sec\n",wcend-wcstart);
  MPI_Finalize();
  return 0;
}

