
program histo

  use, intrinsic :: iso_c_binding
  use mpi_f08
  implicit none

  interface
    integer(c_int) function rand_r(seed) bind(c)
    import :: c_int
    integer(c_int), intent(in) :: seed
    end function
  end interface

  integer(c_int):: value, seed
  real(kind=8):: w, sum, x, pi, f, wct_start, wct_end, c
  integer(kind=8):: i, n, ntot, hist(0:15), hist_tmp(0:15)
  integer:: ind, iproc, nproc, jproc
  type(MPI_STATUS):: status
  call MPI_INIT()
  call MPI_COMM_RANK(MPI_COMM_WORLD,iproc)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,nproc)
  ntot=int(2,kind=8)*int(10,kind=8)**9 !8-byte integer of 2*10^9
  n=ntot/int(nproc,kind=8)+1
  seed = 123+iproc
  do i=0,15
    hist(i) = 0
  enddo

  call timing(wct_start,c)
  do i=1,n
    value = rand_r(seed)
    ind=IAND(value,15)
    hist(ind) = hist(ind) + 1
  enddo
  if(iproc==0) then
      do jproc=1,nproc-1
        call MPI_RECV(hist_tmp,16,MPI_INTEGER8,MPI_ANY_SOURCE,111,MPI_COMM_WORLD,status)
        hist=hist+hist_tmp
      enddo
  else
        call MPI_SEND(hist,16,MPI_INTEGER8,0,111,MPI_COMM_WORLD)
  endif
  call timing(wct_end,c)

  if(iproc==0) then
    do i=0,15
      write(*,'(a,i2,a,i)') "hist (",i,")=",hist(i)
    enddo
  endif

  write(*,*) "Time = ",wct_end-wct_start,"seconds"
  call MPI_FINALIZE()
end program histo

