#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <omp.h>
#include "timing.h"

int main() {
  unsigned int seed = 123;
  long hist[16], j, n;
  int i;
  double wcstart,wcend,ct;
  n=2*pow(10,9);
  for(i=0; i<16; ++i)
    hist[i]=0;

  timing(&wcstart, &ct);

#pragma omp parallel 
{
  unsigned int seed = omp_get_thread_num();
  #pragma omp for reduction(+:hist[0:16])
  for(j=0; j<n; ++j) {
    hist[rand_r(&seed) & 0xf]++;
  }

}
  timing(&wcend, &ct);

  for(i=0; i<16; ++i) {
    printf("hist[%d]=%ld\n",i,hist[i]);
  }

  printf("Time: %lf sec\n",wcend-wcstart);

  return 0;
}

