#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include "timing.h"

int main() {
  unsigned int seed = 123;
  long hist[16],j;
  int i;
  double wcstart,wcend,ct;

  for(i=0; i<16; ++i)
    hist[i]=0;

  timing(&wcstart, &ct);
#pragma omp parallel 
{
  unsigned int seed = omp_get_thread_num();
  long local_hist[16];
  for(j=0; j<16; ++j) local_hist[j]=0;

  #pragma omp for
  for(j=0; j<2000000000; ++j) {
    local_hist[rand_r(&seed) & 0xf]++;
  }

#pragma omp critical
  for(j=0; j<16; ++j) {
    hist[j]+= local_hist[j];
  }
}
  timing(&wcend, &ct);

  for(i=0; i<16; ++i) {
    printf("hist[%d]=%ld\n",i,hist[i]);
  }

  printf("Time: %lf sec\n",wcend-wcstart);
  
  return 0;
}

