
program histo

  use, intrinsic :: iso_c_binding
  use omp_lib
  implicit none

  interface
    integer(c_int) function rand_r(seed) bind(c)
    import :: c_int
    integer(c_int), intent(in) :: seed
    end function
  end interface

  integer(c_int):: value, seed
  real(kind=8):: w, sum, x, pi, f, wct_start, wct_end, c
  integer(kind=8):: i, n, hist(0:15)
  integer:: ind
  n=int(2,kind=8)*int(10,kind=8)**9 !8-byte integer of 2*10^9
  seed = 123
  do i=0,15
    hist(i) = 0
  enddo

  call timing(wct_start,c)
  !$omp parallel private(seed)
  seed = omp_get_thread_num()
  !$omp do private(value,ind) reduction(+:hist)
  do i=1,n
    value = rand_r(seed)
    ind=IAND(value,15)
    hist(ind) = hist(ind) + 1
  enddo
  !$omp end do
  !$omp end parallel
  call timing(wct_end,c)

  do i=0,15
    write(*,'(a,i2,a,i)') "hist (",i,")=",hist(i)
  enddo

  write(*,*) "Time = ",wct_end-wct_start,"seconds"

end program histo

