#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <omp.h>
#include <mpi.h>

#include "timing.h"

int main(int argc, char** argv) {
  double wcstart,wcend,ct,x,y,pi;
  int i,count=0,rcount=0,nn=342000000,size,rank;

  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  
  timing(&wcstart, &ct);

  int lnn = nn/size;
  unsigned int seed = rank;
  
  for(i=0; i<lnn; ++i) {
    x = rand_r(&seed)/(double)RAND_MAX;
    y = rand_r(&seed)/(double)RAND_MAX;
    if(sqrt(x*x+y*y) <1.0) ++count;
  }  

  MPI_Reduce(&count, &rcount, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
  timing(&wcend, &ct);
  
  if(0==rank) {
    pi = 4.0*(double)rcount/nn; 
    
    printf("Time: %.3lf sec, accuracy: %.15le\n",(wcend-wcstart),fabs(M_PI-pi)/M_PI);
  }
  
  MPI_Finalize();
  return 0;
}

  
