#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <omp.h>

#include "timing.h"

int main() {
  double wcstart,wcend,ct,x,y,pi;
  unsigned int seed = 123;
  int i,count=0,nn=342000000;
  
  timing(&wcstart, &ct);
  double rcp = 1./RAND_MAX;

  #pragma omp parallel private(x,y) 
  {
    unsigned int seed = omp_get_thread_num();
    #pragma omp for reduction(+:count)
    for(i=0; i<nn; ++i) {
      x = rand_r(&seed)/(double)RAND_MAX;
      y = rand_r(&seed)/(double)RAND_MAX;
      if(sqrt(x*x+y*y) <1.0) ++count;
    }  
  }
  pi = 4.0*(double)count/nn; 

  timing(&wcend, &ct);
 
  printf("Time: %.3lf sec, accuracy: %.15le\n",(wcend-wcstart),fabs(M_PI-pi)/M_PI);

  return 0;
}

  
